package test.laliluna.tutorial.library;

import java.io.File;
import java.util.ArrayList;

import servletunit.struts.MockStrutsTestCase;
import de.laliluna.tutorial.library.Book;
import de.laliluna.tutorial.library.struts.form.BookEditForm;
import de.laliluna.tutorial.library.struts.form.BookListForm;

/**
 * @author http://www.laliluna.de
 */
public class TestLibrary extends MockStrutsTestCase {

    private BookEditForm bookEditForm;

    public TestLibrary(String testName) {
        super(testName);
    }

    public void setUp() throws Exception {
        super.setUp();
        // set the context directory to /WebRoot
        // to find the /WEB-INF/web.xml
        setContextDirectory(new File("WebRoot"));
        
        // set the book into the action form
        bookEditForm = new BookEditForm();
        bookEditForm.setBook(new Book(1, "laliluna", "StrutsTestCases Tutorial", true));
       
    }

    public void testSaveBook() {

        setRequestPathInfo("/bookEdit");
        addRequestParameter("do", "saveBook");
        setActionForm(bookEditForm);
        actionPerform();
        ArrayList bookDB = (ArrayList) getSession().getAttribute("bookDB");
        assertEquals("StrutsTestCases Tutorial", ((Book) bookDB.get(bookDB.size() - 1)).getTitle());
        verifyForward("showList");
    }
    
    public void testBookList(){
        
        setRequestPathInfo("/bookList");
        actionPerform();
        assertNotNull(((BookListForm)getActionForm()).getBooks());
        verifyForward("showList");
        
    }
}